﻿using System;
using System.Threading;
using System.Windows.Forms;

namespace ExhaustedActivityIndicator
{
    public partial class Form1 : Form
    {
        private static OtherPumpForm _otherPumpForm;

        private int _countdown = 3;

        public Form1()
        {
            InitializeComponent();
        }

        private void _countdownToHeavyMainUI_Tick(object sender, EventArgs e)
        {
            _countdown--;

            _countdownLabel.Text = _countdown.ToString();

            if (_countdown == 0)
            {
                _countdown = 3;

                _countdownToHeavyMainUI.Stop();

                DoHeavyLifting();
                
                _countdownLabel.Text = "done";
            }
        }

        private Thread _pump2thread;

        private void _startButton_Click(object sender, EventArgs e)
        {
            _startButton.Enabled = false;

            _countdownToHeavyMainUI.Start();
            _pump2thread = new Thread(CreateForm) { Name = "UI2", IsBackground = true };
            _pump2thread.Start();
        }

        private static void CreateForm()
        {
            _otherPumpForm = new OtherPumpForm();
            Application.Run(_otherPumpForm);
        }

        private void KillFloater()
        {
            if (_otherPumpForm == null)
                return;

            if (_otherPumpForm.InvokeRequired)
            {
                _otherPumpForm.Invoke(new MethodInvoker(KillFloater));
                return;
            }

            _otherPumpForm.Close();
            _pump2thread = null;
            _otherPumpForm = null;
        }

        private void DoHeavyLifting()
        {
            var control = new MainUIControl();
            Controls.Add(control);
        }
    }
}
